// ==============================================================
// Generated by Vitis HLS v2023.2
// Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// Copyright 2022-2023 Advanced Micro Devices, Inc. All Rights Reserved.
// ==============================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="OQPSKMod_OQPSKMod,hls_ip_2023_2,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg400-1,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=7.300000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=4,HLS_SYN_DSP=0,HLS_SYN_FF=1242,HLS_SYN_LUT=1458,HLS_VERSION=2023_2}" *)

module OQPSKMod (
        ap_clk,
        ap_rst_n,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        inStream_TDATA,
        inStream_TVALID,
        inStream_TREADY,
        inStream_TKEEP,
        inStream_TSTRB,
        inStream_TLAST,
        outStream_TDATA,
        outStream_TVALID,
        outStream_TREADY,
        outStream_TKEEP,
        outStream_TSTRB,
        outStream_TLAST
);

parameter    ap_ST_fsm_state1 = 12'd1;
parameter    ap_ST_fsm_state2 = 12'd2;
parameter    ap_ST_fsm_state3 = 12'd4;
parameter    ap_ST_fsm_state4 = 12'd8;
parameter    ap_ST_fsm_state5 = 12'd16;
parameter    ap_ST_fsm_state6 = 12'd32;
parameter    ap_ST_fsm_state7 = 12'd64;
parameter    ap_ST_fsm_state8 = 12'd128;
parameter    ap_ST_fsm_state9 = 12'd256;
parameter    ap_ST_fsm_state10 = 12'd512;
parameter    ap_ST_fsm_state11 = 12'd1024;
parameter    ap_ST_fsm_state12 = 12'd2048;

input   ap_clk;
input   ap_rst_n;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [39:0] inStream_TDATA;
input   inStream_TVALID;
output   inStream_TREADY;
input  [4:0] inStream_TKEEP;
input  [4:0] inStream_TSTRB;
input  [0:0] inStream_TLAST;
output  [31:0] outStream_TDATA;
output   outStream_TVALID;
input   outStream_TREADY;
output  [3:0] outStream_TKEEP;
output  [3:0] outStream_TSTRB;
output  [0:0] outStream_TLAST;

reg ap_done;
reg ap_idle;
reg ap_ready;

 reg    ap_rst_n_inv;
(* fsm_encoding = "none" *) reg   [11:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg    inStream_TDATA_blk_n;
wire    ap_CS_fsm_state2;
reg   [39:0] current_data_reg_187;
reg   [0:0] current_last_reg_192;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_done;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_idle;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_ready;
wire   [15:0] grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_din;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_write;
wire   [15:0] grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_din;
wire    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_write;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_done;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_idle;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_ready;
wire   [15:0] grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_din;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_write;
wire   [15:0] grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_din;
wire    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_write;
reg    grp_run_fu_127_ap_ce;
wire    grp_run_fu_127_ap_start;
wire    grp_run_fu_127_ap_done;
wire    grp_run_fu_127_ap_idle;
wire    grp_run_fu_127_ap_ready;
wire    grp_run_fu_127_in_V_read;
wire   [15:0] grp_run_fu_127_out_V_din;
wire    grp_run_fu_127_out_V_write;
wire    grp_run_fu_133_ap_done;
reg    ap_block_state9_on_subcall_done;
wire    ap_CS_fsm_state8;
wire    ap_CS_fsm_state9;
reg    grp_run_fu_133_ap_ce;
wire    grp_run_fu_133_ap_start;
wire    grp_run_fu_133_ap_idle;
wire    grp_run_fu_133_ap_ready;
wire    grp_run_fu_133_in_V_read;
wire   [15:0] grp_run_fu_133_out_V_din;
wire    grp_run_fu_133_out_V_write;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_done;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_idle;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_ready;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferQ_read;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferI_read;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TREADY;
wire   [31:0] grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TDATA;
wire    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID;
wire   [3:0] grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TKEEP;
wire   [3:0] grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TSTRB;
wire   [0:0] grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TLAST;
reg    grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg;
wire    ap_CS_fsm_state3;
reg   [15:0] internalBufferI_din;
wire    internalBufferI_full_n;
reg    internalBufferI_write;
wire    ap_CS_fsm_state4;
reg   [15:0] internalBufferQ_din;
wire    internalBufferQ_full_n;
reg    internalBufferQ_write;
reg    grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg;
wire    ap_CS_fsm_state6;
wire    ap_CS_fsm_state7;
reg    grp_run_fu_127_ap_start_reg;
wire   [15:0] internalBufferI_dout;
wire    internalBufferI_empty_n;
reg    internalBufferI_read;
wire    filteredBufferI_full_n;
reg    filteredBufferI_write;
reg    grp_run_fu_133_ap_start_reg;
wire   [15:0] internalBufferQ_dout;
wire    internalBufferQ_empty_n;
reg    internalBufferQ_read;
wire    filteredBufferQ_full_n;
reg    filteredBufferQ_write;
reg    grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg;
wire    ap_CS_fsm_state10;
wire   [15:0] filteredBufferQ_dout;
wire    filteredBufferQ_empty_n;
reg    filteredBufferQ_read;
wire    ap_CS_fsm_state11;
wire   [15:0] filteredBufferI_dout;
wire    filteredBufferI_empty_n;
reg    filteredBufferI_read;
wire    ap_CS_fsm_state12;
wire    regslice_both_outStream_V_data_V_U_apdone_blk;
reg   [11:0] ap_NS_fsm;
reg    ap_ST_fsm_state1_blk;
reg    ap_ST_fsm_state2_blk;
wire    ap_ST_fsm_state3_blk;
reg    ap_ST_fsm_state4_blk;
wire    ap_ST_fsm_state5_blk;
wire    ap_ST_fsm_state6_blk;
reg    ap_ST_fsm_state7_blk;
wire    ap_ST_fsm_state8_blk;
reg    ap_ST_fsm_state9_blk;
wire    ap_ST_fsm_state10_blk;
reg    ap_ST_fsm_state11_blk;
reg    ap_ST_fsm_state12_blk;
wire    regslice_both_inStream_V_data_V_U_apdone_blk;
wire   [39:0] inStream_TDATA_int_regslice;
wire    inStream_TVALID_int_regslice;
reg    inStream_TREADY_int_regslice;
wire    regslice_both_inStream_V_data_V_U_ack_in;
wire    regslice_both_inStream_V_keep_V_U_apdone_blk;
wire   [4:0] inStream_TKEEP_int_regslice;
wire    regslice_both_inStream_V_keep_V_U_vld_out;
wire    regslice_both_inStream_V_keep_V_U_ack_in;
wire    regslice_both_inStream_V_strb_V_U_apdone_blk;
wire   [4:0] inStream_TSTRB_int_regslice;
wire    regslice_both_inStream_V_strb_V_U_vld_out;
wire    regslice_both_inStream_V_strb_V_U_ack_in;
wire    regslice_both_inStream_V_last_V_U_apdone_blk;
wire   [0:0] inStream_TLAST_int_regslice;
wire    regslice_both_inStream_V_last_V_U_vld_out;
wire    regslice_both_inStream_V_last_V_U_ack_in;
wire    outStream_TVALID_int_regslice;
wire    outStream_TREADY_int_regslice;
wire    regslice_both_outStream_V_data_V_U_vld_out;
wire    regslice_both_outStream_V_keep_V_U_apdone_blk;
wire    regslice_both_outStream_V_keep_V_U_ack_in_dummy;
wire    regslice_both_outStream_V_keep_V_U_vld_out;
wire    regslice_both_outStream_V_strb_V_U_apdone_blk;
wire    regslice_both_outStream_V_strb_V_U_ack_in_dummy;
wire    regslice_both_outStream_V_strb_V_U_vld_out;
wire    regslice_both_outStream_V_last_V_U_apdone_blk;
wire    regslice_both_outStream_V_last_V_U_ack_in_dummy;
wire    regslice_both_outStream_V_last_V_U_vld_out;
wire    ap_ce_reg;

// power-on initialization
initial begin
#0 ap_CS_fsm = 12'd1;
#0 grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg = 1'b0;
#0 grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg = 1'b0;
#0 grp_run_fu_127_ap_start_reg = 1'b0;
#0 grp_run_fu_133_ap_start_reg = 1'b0;
#0 grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg = 1'b0;
end

OQPSKMod_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .ap_start(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start),
    .ap_done(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_done),
    .ap_idle(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_idle),
    .ap_ready(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_ready),
    .internalBufferI_din(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_din),
    .internalBufferI_full_n(internalBufferI_full_n),
    .internalBufferI_write(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_write),
    .internalBufferQ_din(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_din),
    .internalBufferQ_full_n(internalBufferQ_full_n),
    .internalBufferQ_write(grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_write),
    .current_data(current_data_reg_187)
);

OQPSKMod_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .ap_start(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start),
    .ap_done(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_done),
    .ap_idle(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_idle),
    .ap_ready(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_ready),
    .internalBufferI_din(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_din),
    .internalBufferI_full_n(internalBufferI_full_n),
    .internalBufferI_write(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_write),
    .internalBufferQ_din(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_din),
    .internalBufferQ_full_n(internalBufferQ_full_n),
    .internalBufferQ_write(grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_write)
);

OQPSKMod_run grp_run_fu_127(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .ap_ce(grp_run_fu_127_ap_ce),
    .ap_start(grp_run_fu_127_ap_start),
    .ap_done(grp_run_fu_127_ap_done),
    .ap_idle(grp_run_fu_127_ap_idle),
    .ap_ready(grp_run_fu_127_ap_ready),
    .in_V_dout(internalBufferI_dout),
    .in_V_empty_n(internalBufferI_empty_n),
    .in_V_read(grp_run_fu_127_in_V_read),
    .out_V_din(grp_run_fu_127_out_V_din),
    .out_V_full_n(filteredBufferI_full_n),
    .out_V_write(grp_run_fu_127_out_V_write)
);

OQPSKMod_run grp_run_fu_133(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .ap_ce(grp_run_fu_133_ap_ce),
    .ap_start(grp_run_fu_133_ap_start),
    .ap_done(grp_run_fu_133_ap_done),
    .ap_idle(grp_run_fu_133_ap_idle),
    .ap_ready(grp_run_fu_133_ap_ready),
    .in_V_dout(internalBufferQ_dout),
    .in_V_empty_n(internalBufferQ_empty_n),
    .in_V_read(grp_run_fu_133_in_V_read),
    .out_V_din(grp_run_fu_133_out_V_din),
    .out_V_full_n(filteredBufferQ_full_n),
    .out_V_write(grp_run_fu_133_out_V_write)
);

OQPSKMod_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .ap_start(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start),
    .ap_done(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_done),
    .ap_idle(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_idle),
    .ap_ready(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_ready),
    .filteredBufferQ_dout(filteredBufferQ_dout),
    .filteredBufferQ_empty_n(filteredBufferQ_empty_n),
    .filteredBufferQ_read(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferQ_read),
    .filteredBufferI_dout(filteredBufferI_dout),
    .filteredBufferI_empty_n(filteredBufferI_empty_n),
    .filteredBufferI_read(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferI_read),
    .outStream_TREADY(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TREADY),
    .outStream_TDATA(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TDATA),
    .outStream_TVALID(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID),
    .outStream_TKEEP(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TKEEP),
    .outStream_TSTRB(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TSTRB),
    .outStream_TLAST(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TLAST)
);

OQPSKMod_fifo_w16_d160_A internalBufferI_fifo_U(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .if_read_ce(1'b1),
    .if_write_ce(1'b1),
    .if_din(internalBufferI_din),
    .if_full_n(internalBufferI_full_n),
    .if_write(internalBufferI_write),
    .if_dout(internalBufferI_dout),
    .if_empty_n(internalBufferI_empty_n),
    .if_read(internalBufferI_read)
);

OQPSKMod_fifo_w16_d160_A internalBufferQ_fifo_U(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .if_read_ce(1'b1),
    .if_write_ce(1'b1),
    .if_din(internalBufferQ_din),
    .if_full_n(internalBufferQ_full_n),
    .if_write(internalBufferQ_write),
    .if_dout(internalBufferQ_dout),
    .if_empty_n(internalBufferQ_empty_n),
    .if_read(internalBufferQ_read)
);

OQPSKMod_fifo_w16_d82_A filteredBufferI_fifo_U(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .if_read_ce(1'b1),
    .if_write_ce(1'b1),
    .if_din(grp_run_fu_127_out_V_din),
    .if_full_n(filteredBufferI_full_n),
    .if_write(filteredBufferI_write),
    .if_dout(filteredBufferI_dout),
    .if_empty_n(filteredBufferI_empty_n),
    .if_read(filteredBufferI_read)
);

OQPSKMod_fifo_w16_d82_A filteredBufferQ_fifo_U(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .if_read_ce(1'b1),
    .if_write_ce(1'b1),
    .if_din(grp_run_fu_133_out_V_din),
    .if_full_n(filteredBufferQ_full_n),
    .if_write(filteredBufferQ_write),
    .if_dout(filteredBufferQ_dout),
    .if_empty_n(filteredBufferQ_empty_n),
    .if_read(filteredBufferQ_read)
);

OQPSKMod_regslice_both #(
    .DataWidth( 40 ))
regslice_both_inStream_V_data_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(inStream_TDATA),
    .vld_in(inStream_TVALID),
    .ack_in(regslice_both_inStream_V_data_V_U_ack_in),
    .data_out(inStream_TDATA_int_regslice),
    .vld_out(inStream_TVALID_int_regslice),
    .ack_out(inStream_TREADY_int_regslice),
    .apdone_blk(regslice_both_inStream_V_data_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 5 ))
regslice_both_inStream_V_keep_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(inStream_TKEEP),
    .vld_in(inStream_TVALID),
    .ack_in(regslice_both_inStream_V_keep_V_U_ack_in),
    .data_out(inStream_TKEEP_int_regslice),
    .vld_out(regslice_both_inStream_V_keep_V_U_vld_out),
    .ack_out(inStream_TREADY_int_regslice),
    .apdone_blk(regslice_both_inStream_V_keep_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 5 ))
regslice_both_inStream_V_strb_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(inStream_TSTRB),
    .vld_in(inStream_TVALID),
    .ack_in(regslice_both_inStream_V_strb_V_U_ack_in),
    .data_out(inStream_TSTRB_int_regslice),
    .vld_out(regslice_both_inStream_V_strb_V_U_vld_out),
    .ack_out(inStream_TREADY_int_regslice),
    .apdone_blk(regslice_both_inStream_V_strb_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 1 ))
regslice_both_inStream_V_last_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(inStream_TLAST),
    .vld_in(inStream_TVALID),
    .ack_in(regslice_both_inStream_V_last_V_U_ack_in),
    .data_out(inStream_TLAST_int_regslice),
    .vld_out(regslice_both_inStream_V_last_V_U_vld_out),
    .ack_out(inStream_TREADY_int_regslice),
    .apdone_blk(regslice_both_inStream_V_last_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 32 ))
regslice_both_outStream_V_data_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TDATA),
    .vld_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID),
    .ack_in(outStream_TREADY_int_regslice),
    .data_out(outStream_TDATA),
    .vld_out(regslice_both_outStream_V_data_V_U_vld_out),
    .ack_out(outStream_TREADY),
    .apdone_blk(regslice_both_outStream_V_data_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 4 ))
regslice_both_outStream_V_keep_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TKEEP),
    .vld_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID),
    .ack_in(regslice_both_outStream_V_keep_V_U_ack_in_dummy),
    .data_out(outStream_TKEEP),
    .vld_out(regslice_both_outStream_V_keep_V_U_vld_out),
    .ack_out(outStream_TREADY),
    .apdone_blk(regslice_both_outStream_V_keep_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 4 ))
regslice_both_outStream_V_strb_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TSTRB),
    .vld_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID),
    .ack_in(regslice_both_outStream_V_strb_V_U_ack_in_dummy),
    .data_out(outStream_TSTRB),
    .vld_out(regslice_both_outStream_V_strb_V_U_vld_out),
    .ack_out(outStream_TREADY),
    .apdone_blk(regslice_both_outStream_V_strb_V_U_apdone_blk)
);

OQPSKMod_regslice_both #(
    .DataWidth( 1 ))
regslice_both_outStream_V_last_V_U(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst_n_inv),
    .data_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TLAST),
    .vld_in(grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID),
    .ack_in(regslice_both_outStream_V_last_V_U_ack_in_dummy),
    .data_out(outStream_TLAST),
    .vld_out(regslice_both_outStream_V_last_V_U_vld_out),
    .ack_out(outStream_TREADY),
    .apdone_blk(regslice_both_outStream_V_last_V_U_apdone_blk)
);

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state3)) begin
            grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg <= 1'b1;
        end else if ((grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_ready == 1'b1)) begin
            grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state10)) begin
            grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg <= 1'b1;
        end else if ((grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_ready == 1'b1)) begin
            grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state6)) begin
            grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg <= 1'b1;
        end else if ((grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_ready == 1'b1)) begin
            grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        grp_run_fu_127_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state8)) begin
            grp_run_fu_127_ap_start_reg <= 1'b1;
        end else if ((grp_run_fu_127_ap_ready == 1'b1)) begin
            grp_run_fu_127_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        grp_run_fu_133_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state8)) begin
            grp_run_fu_133_ap_start_reg <= 1'b1;
        end else if ((grp_run_fu_133_ap_ready == 1'b1)) begin
            grp_run_fu_133_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        current_data_reg_187 <= inStream_TDATA_int_regslice;
        current_last_reg_192 <= inStream_TLAST_int_regslice;
    end
end

assign ap_ST_fsm_state10_blk = 1'b0;

always @ (*) begin
    if ((grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_done == 1'b0)) begin
        ap_ST_fsm_state11_blk = 1'b1;
    end else begin
        ap_ST_fsm_state11_blk = 1'b0;
    end
end

always @ (*) begin
    if ((regslice_both_outStream_V_data_V_U_apdone_blk == 1'b1)) begin
        ap_ST_fsm_state12_blk = 1'b1;
    end else begin
        ap_ST_fsm_state12_blk = 1'b0;
    end
end

always @ (*) begin
    if ((ap_start == 1'b0)) begin
        ap_ST_fsm_state1_blk = 1'b1;
    end else begin
        ap_ST_fsm_state1_blk = 1'b0;
    end
end

always @ (*) begin
    if ((inStream_TVALID_int_regslice == 1'b0)) begin
        ap_ST_fsm_state2_blk = 1'b1;
    end else begin
        ap_ST_fsm_state2_blk = 1'b0;
    end
end

assign ap_ST_fsm_state3_blk = 1'b0;

always @ (*) begin
    if ((grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_done == 1'b0)) begin
        ap_ST_fsm_state4_blk = 1'b1;
    end else begin
        ap_ST_fsm_state4_blk = 1'b0;
    end
end

assign ap_ST_fsm_state5_blk = 1'b0;

assign ap_ST_fsm_state6_blk = 1'b0;

always @ (*) begin
    if ((grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_done == 1'b0)) begin
        ap_ST_fsm_state7_blk = 1'b1;
    end else begin
        ap_ST_fsm_state7_blk = 1'b0;
    end
end

assign ap_ST_fsm_state8_blk = 1'b0;

always @ (*) begin
    if ((1'b1 == ap_block_state9_on_subcall_done)) begin
        ap_ST_fsm_state9_blk = 1'b1;
    end else begin
        ap_ST_fsm_state9_blk = 1'b0;
    end
end

always @ (*) begin
    if (((regslice_both_outStream_V_data_V_U_apdone_blk == 1'b0) & (1'b1 == ap_CS_fsm_state12))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b0))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if (((regslice_both_outStream_V_data_V_U_apdone_blk == 1'b0) & (1'b1 == ap_CS_fsm_state12))) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state11)) begin
        filteredBufferI_read = grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferI_read;
    end else begin
        filteredBufferI_read = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        filteredBufferI_write = grp_run_fu_127_out_V_write;
    end else begin
        filteredBufferI_write = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state11)) begin
        filteredBufferQ_read = grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_filteredBufferQ_read;
    end else begin
        filteredBufferQ_read = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        filteredBufferQ_write = grp_run_fu_133_out_V_write;
    end else begin
        filteredBufferQ_write = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        grp_run_fu_127_ap_ce = 1'b1;
    end else begin
        grp_run_fu_127_ap_ce = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        grp_run_fu_133_ap_ce = 1'b1;
    end else begin
        grp_run_fu_133_ap_ce = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        inStream_TDATA_blk_n = inStream_TVALID_int_regslice;
    end else begin
        inStream_TDATA_blk_n = 1'b1;
    end
end

always @ (*) begin
    if (((inStream_TVALID_int_regslice == 1'b1) & (1'b1 == ap_CS_fsm_state2))) begin
        inStream_TREADY_int_regslice = 1'b1;
    end else begin
        inStream_TREADY_int_regslice = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        internalBufferI_din = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_din;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        internalBufferI_din = grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_din;
    end else begin
        internalBufferI_din = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_din;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        internalBufferI_read = grp_run_fu_127_in_V_read;
    end else begin
        internalBufferI_read = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        internalBufferI_write = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferI_write;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        internalBufferI_write = grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferI_write;
    end else begin
        internalBufferI_write = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        internalBufferQ_din = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_din;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        internalBufferQ_din = grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_din;
    end else begin
        internalBufferQ_din = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_din;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) | (1'b1 == ap_CS_fsm_state8))) begin
        internalBufferQ_read = grp_run_fu_133_in_V_read;
    end else begin
        internalBufferQ_read = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        internalBufferQ_write = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_internalBufferQ_write;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        internalBufferQ_write = grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_internalBufferQ_write;
    end else begin
        internalBufferQ_write = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            if (((inStream_TVALID_int_regslice == 1'b1) & (1'b1 == ap_CS_fsm_state2))) begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            if (((grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_done == 1'b1) & (1'b1 == ap_CS_fsm_state4))) begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state5 : begin
            ap_NS_fsm = ap_ST_fsm_state6;
        end
        ap_ST_fsm_state6 : begin
            ap_NS_fsm = ap_ST_fsm_state7;
        end
        ap_ST_fsm_state7 : begin
            if (((grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_done == 1'b1) & (1'b1 == ap_CS_fsm_state7))) begin
                ap_NS_fsm = ap_ST_fsm_state8;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state7;
            end
        end
        ap_ST_fsm_state8 : begin
            ap_NS_fsm = ap_ST_fsm_state9;
        end
        ap_ST_fsm_state9 : begin
            if (((1'b0 == ap_block_state9_on_subcall_done) & (1'b1 == ap_CS_fsm_state9))) begin
                ap_NS_fsm = ap_ST_fsm_state10;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state9;
            end
        end
        ap_ST_fsm_state10 : begin
            ap_NS_fsm = ap_ST_fsm_state11;
        end
        ap_ST_fsm_state11 : begin
            if (((current_last_reg_192 == 1'd1) & (1'b1 == ap_CS_fsm_state11) & (grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_done == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state12;
            end else if (((current_last_reg_192 == 1'd0) & (1'b1 == ap_CS_fsm_state11) & (grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_done == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state11;
            end
        end
        ap_ST_fsm_state12 : begin
            if (((regslice_both_outStream_V_data_V_U_apdone_blk == 1'b0) & (1'b1 == ap_CS_fsm_state12))) begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state12;
            end
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state10 = ap_CS_fsm[32'd9];

assign ap_CS_fsm_state11 = ap_CS_fsm[32'd10];

assign ap_CS_fsm_state12 = ap_CS_fsm[32'd11];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state6 = ap_CS_fsm[32'd5];

assign ap_CS_fsm_state7 = ap_CS_fsm[32'd6];

assign ap_CS_fsm_state8 = ap_CS_fsm[32'd7];

assign ap_CS_fsm_state9 = ap_CS_fsm[32'd8];

always @ (*) begin
    ap_block_state9_on_subcall_done = ((grp_run_fu_133_ap_done == 1'b0) | (grp_run_fu_127_ap_done == 1'b0));
end

always @ (*) begin
    ap_rst_n_inv = ~ap_rst_n;
end

assign grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start = grp_OQPSKMod_Pipeline_OQPSK_CONSTELLATION_MAPPING_fu_114_ap_start_reg;

assign grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start = grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_ap_start_reg;

assign grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TREADY = (outStream_TREADY_int_regslice & ap_CS_fsm_state11);

assign grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start = grp_OQPSKMod_Pipeline_OQPSK_TIME_DOMAIN_SHIFT_fu_121_ap_start_reg;

assign grp_run_fu_127_ap_start = grp_run_fu_127_ap_start_reg;

assign grp_run_fu_133_ap_start = grp_run_fu_133_ap_start_reg;

assign inStream_TREADY = regslice_both_inStream_V_data_V_U_ack_in;

assign outStream_TVALID = regslice_both_outStream_V_data_V_U_vld_out;

assign outStream_TVALID_int_regslice = grp_OQPSKMod_Pipeline_OQPSK_PULSE_PACKETISATION_fu_139_outStream_TVALID;


reg find_kernel_block = 0;
// synthesis translate_off
`include "OQPSKMod_hls_deadlock_kernel_monitor_top.vh"
// synthesis translate_on

endmodule //OQPSKMod

